package com.devdaily.meditation;

import javax.swing.JLabel;

/**
 * Copyright 2009 Alvin J. Alexander, devdaily.com.
 * 
 * This file is part of my "Meditation" application.
 *
 * The Meditation application is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * The Meditation application is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with the Meditation application. If not, see <http://www.gnu.org/licenses/>.
 *
 */
public class ThreadedCountdownField extends Thread
{
  private Meditation meditation;
  private JLabel timeRemainingLabel;
  private long timeRemaining;

  /**
   * @param meditation Our controller class, needed for a callback to doEndOfTimerAction().
   * @param timeLabel The JLabel we will update.
   * @param timeToSleep Time to sleep, in seconds.
   */
  ThreadedCountdownField(Meditation meditation, JLabel timeLabel, long timeToSleep)
  {
    this.meditation = meditation;
    this.timeRemainingLabel = timeLabel;
    timeRemaining = timeToSleep;
  }

  public void run()
  {
    // TODO test, is this running on the EDT? should be, it is triggered from the start button
    
    while (timeRemaining > 0)
    {
      timeRemainingLabel.setText("time to sleep: " + Long.toString(timeRemaining) + " seconds");
      try
      {
        Thread.sleep(1000);
      }
      catch (InterruptedException e)
      {
        if (meditation.getDebugFileWriter()!=null) e.printStackTrace(meditation.getDebugFileWriter());
      }
      timeRemaining--;
    }

    timeRemainingLabel.setText("");
    meditation.doEndOfTimerAction();
  }

}



